# COMPSCI 365
# Spring 2020
# YOUR NAME HERE
# Assignment 2: Carver

# Complete the relevant functions.
# Make sure to test your implementations.
# You can import any standard library.
# You can define any new function you want.

# * EXCEPTIONS: You may not use str.encode() OR bytes.decode().
# * This includes directly and indirectly.
# * bin(), chr(), and ord() are not allowed.
# * For example, bytes(chr(codePoint)) calls
# * str.encode() and therefore is not allowed.
# * You need to work with the bits yourself.
# * Work with values of type int; do NOT call
# * bin() to convert to strings and use
# * string manipulation instead.

def utf8_search(inputFile, codePoint):
    """
    Description: Read the input file and search for the given
    # code point in UTF-8 format. Only find the FIRST occurrence
    # if there are multiple. Return the offset (the number
    # of bytes into the file, where the first byte starts at 0,
    # ex. the 11th byte is at offset 10) as a string in LOWERCASE
    # hexadecimal format of the first byte where the code point
    # is found, ex. "0x00000094". It should be left-padded with
    # zeroes up to eight characters (represents max. 16^8 bytes).
    # The codePoint will be in UPPERCASE format.
    # If it does not exist in the file, then return an empty string.
    Input: string inputFile, string codePoint
    Output: string
    Example: utf8_search("main.py", "U+0050") = "0x00000076"
    """
    pass

def utf8_carve(inputFile):
    """
    Description: Read the input file and extract all valid
    # UTF-8 characters that are in any of the following planes:
    # U+0000 to U+FFFF, U+10000 to U+1FFFF, U+20000 to U+2FFFF
    # If a character is valid and in one of those planes, but
    # is not defined, you still treat it as a character and
    # extract it. Each valid UTF-8 character extracted
    # should be represented with a (offset, codePoint) format.
    # The output should be a list of those formats (i.e. a list
    # of tuples). The offset string should be in the same format
    # as specified in the utf8_search function. The codePoint
    # string should be in the Unicode code format, i.e. "U+XXXX"
    # or "U+XXXXX" (number of X's depends on the plane it is in).
    # The ordering of the output list does not matter. The codePoint
    # should be in UPPERCASE, but the offset should be in LOWERCASE.
    # If there are no valid characters, return an empty list.
    # NOTE: REMEMBER THAT WE ARE CARVING FOR CHARACTERS THAT CAN BE
    # ANYWHERE BETWEEN 1 AND 4 BYTES. MAKE SURE YOU COVER ALL OF THOSE
    # CASES.
    Input: string inputFile
    Output: list of tuples (string offset, string codePoint)
    Example: utf8_carve("main.py") = [("0x00000000", "U+0069"),
    # ("0x00000001", "U+006D"), ("0x00000002", "U+0070"), ... ]
    """
    pass
